/* Title: Trivial example with Capsicum sandbox */

#include <sys/resource.h>
#include <sys/capability.h>

#include <err.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

int
main(void)
{
	cap_rights_t	 rights;

	/* 
	 * Limit to stdout, stderr, stdin. 
	 * (We only use stdout in this application.)
	 */

	cap_rights_init(&rights, CAP_EVENT, 
		CAP_WRITE, CAP_FSTAT);
	if (cap_rights_limit(STDOUT_FILENO, &rights) < 0)
		err(EXIT_FAILURE, NULL);
	cap_rights_init(&rights, CAP_EVENT, 
		CAP_WRITE, CAP_FSTAT);
	if (cap_rights_limit(STDERR_FILENO, &rights) < 0)
		err(EXIT_FAILURE, NULL);
	cap_rights_init(&rights, CAP_EVENT, 
		CAP_READ, CAP_FSTAT);
	if (cap_rights_limit(STDIN_FILENO, &rights) < 0)
		err(EXIT_FAILURE, NULL);
	if (cap_enter())
		err(EXIT_FAILURE, NULL);

	puts("Status: 200 OK\r");
	puts("Content-Type: text/html\r");
	puts("\r");
	puts("Hello, world!");
	return(EXIT_SUCCESS);
}
